package sms.example.smstooth;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.provider.Telephony;
import android.support.v7.app.AppCompatActivity;
import android.telephony.SmsManager;
import android.telephony.SmsMessage;
import android.widget.TextView;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Set;

public class StartupActivity extends AppCompatActivity {

    static String PhoneNum;
    static String s2="";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_slanje);

        final TextView Broj = (TextView) findViewById(R.id.textView);
        final TextView Poruka = (TextView) findViewById(R.id.textView2);
        final TextView Datum = (TextView) findViewById(R.id.textView3);

        BluetoothAdapter adapter = BluetoothAdapter.getDefaultAdapter();
        Set<BluetoothDevice> pairedDevices = adapter.getBondedDevices();

        BluetoothDevice hc = (BluetoothDevice) pairedDevices.toArray()[0];

        try {
            ConnectionHandler.getInstance().connect(hc);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (DeviceNotConnectedException e) {
            e.printStackTrace();
        }


        BroadcastReceiver r = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if (Telephony.Sms.Intents.SMS_RECEIVED_ACTION.equals(intent.getAction())) {
                    for (SmsMessage smsMessage : Telephony.Sms.Intents.getMessagesFromIntent(intent)) {
                        String messageBody = smsMessage.getMessageBody()+'\n';
                        try {
                            ConnectionHandler.getInstance().sendBytes(messageBody.getBytes());
                            PhoneNum = smsMessage.getDisplayOriginatingAddress();
                            Broj.setText(PhoneNum);
                            Poruka.setText(smsMessage.getDisplayMessageBody());
                            Calendar calendar = Calendar.getInstance();
                            calendar.setTimeInMillis(smsMessage.getTimestampMillis());
                            DateFormat formatter = new SimpleDateFormat("dd/MM/yyyy  HH:mm");
                            String finalDateString=formatter.format(calendar.getTime());
                            Datum.setText(finalDateString);
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }
        };



        ConnectionHandler.getInstance().addBluetoothConnectionListener(new BluetoothConnectionListener() {
            @Override
            public void dataReceived(byte[] data) {
                try {
                    if (data[data.length-1]=='.'){
                        s2=s2+new String (data);
                        //sendSMS(s2);
                        s2="";
                    }else{
                         s2=s2 + new String(data);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        });

        IntentFilter i = new IntentFilter("android.provider.Telephony.SMS_RECEIVED");
        registerReceiver(r, i);

    }

    public void sendSMS(String message){
        SmsManager sms = SmsManager.getDefault();
        sms.sendTextMessage(PhoneNum, null, message, null, null);
    }


        //ConnectionHandler.getInstance().connect(device);

}


