#include <stdio.h>
#include <stm32f4xx.h>
#include <stm32f4xx_gpio.h>
#include <stm32f4xx_usart.h>
#include <misc.h>


extern void init_pio(void){

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE); //ukljuci takt za periferiju D

  GPIO_InitTypeDef GPIO_InitStruct;

  GPIO_InitStruct.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14;	//koristiti cu izlaze 13 i 14 (LED)
  GPIO_InitStruct.GPIO_Mode = GPIO_Mode_OUT; //izlaz
	GPIO_InitStruct.GPIO_Speed = GPIO_Medium_Speed; //brzina 2MHz
  GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;	//pull down
  GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_DOWN; //provjeri

  GPIO_Init(GPIOD, &GPIO_InitStruct);
}


extern void init_usart1(uint32_t baudrate){

	USART_InitTypeDef USART_InitStruct;
	GPIO_InitTypeDef GPIO_InitUsart;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);//takt usart1

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);//takt za periferiju B

	GPIO_InitUsart.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7; // pinovi 6(tx) i 7(rx)
	GPIO_InitUsart.GPIO_Mode = GPIO_Mode_AF; //alternating mode
	GPIO_InitUsart.GPIO_OType = GPIO_OType_PP;
	GPIO_InitUsart.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_InitUsart.GPIO_Speed = GPIO_Medium_Speed;

	GPIO_Init(GPIOB, &GPIO_InitUsart);

	GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_USART1); //pin 6 i 7 cu koristiti kao tx i rx za usart1
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource7, GPIO_AF_USART1);

	USART_InitStruct.USART_BaudRate = baudrate;
	USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStruct.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
	USART_InitStruct.USART_Parity = USART_Parity_No;
	USART_InitStruct.USART_StopBits = USART_StopBits_1;
	USART_InitStruct.USART_WordLength = USART_WordLength_8b;

	USART_Init(USART1, &USART_InitStruct);

	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE); //enable usart1 interrupt
}

extern void init_nvic(void){

NVIC_InitTypeDef NVIC_InitStruct;

NVIC_InitStruct.NVIC_IRQChannel = USART1_IRQn;
NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 0;
NVIC_InitStruct.NVIC_IRQChannelSubPriority = 0;
NVIC_Init(&NVIC_InitStruct);

USART_Cmd(USART1, ENABLE);
}


extern void USART_puts(USART_TypeDef* USARTx, volatile char *s){

	while(*s){
		// wait until data register is empty
		while( !(USARTx->SR & 0x00000040) );
		USART_SendData(USARTx, *s);
		s++;
	}
}
