#include <stdio.h>
#include <stm32f4xx.h>
#include <stm32f4xx_gpio.h>
#include <stm32f4xx_usart.h>
#include <misc.h>
#include <string.h>

#define BAUD 9600
#define MAX_STRLEN 25 // this is the maximum string length of our string in characters

volatile char received_string[MAX_STRLEN+1]; // this will hold the recieved string

void Delay( uint32_t a){
	while(a--);
};

extern void init_pio(void);
extern void init_usart1(uint32_t baudrate);
extern void init_nvic(void);
void USART1_IRQHandler(void);
extern void USART_puts(USART_TypeDef* USARTx, volatile char *s);

int main(void){
	init_pio();
	init_usart1(BAUD);
	init_nvic();

//	USART_puts(USART1, "OK.");
//	Delay(8000000);
//	USART_puts(USART1, "AT\r\n");
//	Delay(8000000);
//	USART_puts(USART1, "AT+ROLE=?\r\n");
//	Delay(8000000);
//	USART_puts(USART1, "AT+UART?\r\n");

	while(1){
		GPIO_ToggleBits(GPIOD, GPIO_Pin_13);
		Delay(15000000);
  }
}

void USART1_IRQHandler(void) {

	if( USART_GetITStatus(USART1, USART_IT_RXNE) ){

		static uint8_t cnt = 0;
		char t = USART1->DR;

		if( (t != '\n') && (cnt <= MAX_STRLEN)){ // otherwise reset the character counter and print izbrisi jos ' '
			received_string[cnt] = t;
			cnt++;
		}else{
			if(!strncmp((const char *)received_string,"On",2)){
				cnt = 0;
				USART_puts(USART1, "Utinica je ukljuena.");
				GPIO_SetBits(GPIOD, GPIO_Pin_14);
			}else if(!strncmp((const char *)received_string,"Off",3)){
				cnt = 0;
				USART_puts(USART1, "Utinica je iskljuena.");
				GPIO_ResetBits(GPIOD, GPIO_Pin_14);
		  }else if(!strncmp((const char *)received_string,"Stanje",6)){
				uint8_t stat;
				cnt=0;
				stat=GPIO_ReadOutputDataBit(GPIOD, GPIO_Pin_14);
				if(stat==Bit_SET){
					USART_puts(USART1, "Utinica je ukljuena.");
				}else{
					USART_puts(USART1, "Utinica je iskljuena.");
				}
			}else{
				cnt = 0;
				USART_puts(USART1, "Kriva naredba.\n\r");
			}
		}
	}
}

